-- --------------------------------------------------------
-- Host:                         127.0.0.1
-- Server version:               10.5.9-MariaDB - mariadb.org binary distribution
-- Server OS:                    Win64
-- HeidiSQL Version:             11.0.0.5919
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!50503 SET NAMES utf8mb4 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;


-- Dumping database structure for caradmin_iot_data
CREATE DATABASE IF NOT EXISTS `caradmin_iot_data` /*!40100 DEFAULT CHARACTER SET utf8 */;
USE `caradmin_iot_data`;

-- Dumping structure for table caradmin_iot_data.datapacket
CREATE TABLE IF NOT EXISTS `datapacket` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `device_id` bigint(20) unsigned NOT NULL,
  `timestamp` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `sensor_id_datapacket` (`device_id`) USING BTREE,
  CONSTRAINT `FK_datapacket_device` FOREIGN KEY (`device_id`) REFERENCES `device` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- Dumping data for table caradmin_iot_data.datapacket: ~0 rows (approximately)
/*!40000 ALTER TABLE `datapacket` DISABLE KEYS */;
/*!40000 ALTER TABLE `datapacket` ENABLE KEYS */;

-- Dumping structure for event caradmin_iot_data.DeleteEvent
DELIMITER //
CREATE EVENT `DeleteEvent` ON SCHEDULE EVERY 1 WEEK STARTS '2021-05-10 12:00:00' ON COMPLETION NOT PRESERVE ENABLE DO BEGIN
DELETE FROM `caradmin_iot_data`.`datapacket` WHERE  `timestamp` < DATE_ADD(NOW(), INTERVAL -1 WEEK);
END//
DELIMITER ;

-- Dumping structure for table caradmin_iot_data.device
CREATE TABLE IF NOT EXISTS `device` (
  `id` bigint(20) unsigned NOT NULL,
  `device_family_id` int(10) unsigned NOT NULL,
  `vehicle_id` int(10) unsigned NOT NULL,
  `name` varchar(50) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `device_family_id_sensor` (`device_family_id`),
  KEY `vehicle_id_sensor` (`vehicle_id`),
  CONSTRAINT `device_family_id_device` FOREIGN KEY (`device_family_id`) REFERENCES `device_family` (`id`),
  CONSTRAINT `vehicle_id_device` FOREIGN KEY (`vehicle_id`) REFERENCES `vehicle` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- Dumping data for table caradmin_iot_data.device: ~6 rows (approximately)
/*!40000 ALTER TABLE `device` DISABLE KEYS */;
REPLACE INTO `device` (`id`, `device_family_id`, `vehicle_id`, `name`) VALUES
	(1, 2, 4, 'FMC130'),
	(2, 1, 1, 'FMB920'),
	(3, 1, 3, 'FMB120'),
	(4, 3, 4, 'CL2000'),
	(5, 3, 2, 'CL1000'),
	(6, 2, 3, 'FMC640');
/*!40000 ALTER TABLE `device` ENABLE KEYS */;

-- Dumping structure for table caradmin_iot_data.device_family
CREATE TABLE IF NOT EXISTS `device_family` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `producer_id` int(10) unsigned NOT NULL,
  `name` varchar(50) NOT NULL,
  `port` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `producer_id_device_family` (`producer_id`),
  CONSTRAINT `producer_id_device_family` FOREIGN KEY (`producer_id`) REFERENCES `producer` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

-- Dumping data for table caradmin_iot_data.device_family: ~3 rows (approximately)
/*!40000 ALTER TABLE `device_family` DISABLE KEYS */;
REPLACE INTO `device_family` (`id`, `producer_id`, `name`, `port`) VALUES
	(1, 1, 'FMB', 500),
	(2, 1, 'FMC', 600),
	(3, 2, 'CL', 1500);
/*!40000 ALTER TABLE `device_family` ENABLE KEYS */;

-- Dumping structure for table caradmin_iot_data.gps_data
CREATE TABLE IF NOT EXISTS `gps_data` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `datapacket_id` int(10) unsigned NOT NULL,
  `longitude` double NOT NULL,
  `latitude` double NOT NULL,
  `altitude` smallint(6) NOT NULL,
  `angle` smallint(6) unsigned NOT NULL,
  `no_of_satellites` tinyint(3) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `datapacket_id_gps` (`datapacket_id`),
  CONSTRAINT `datapacket_id_gps` FOREIGN KEY (`datapacket_id`) REFERENCES `datapacket` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- Dumping data for table caradmin_iot_data.gps_data: ~0 rows (approximately)
/*!40000 ALTER TABLE `gps_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `gps_data` ENABLE KEYS */;

-- Dumping structure for table caradmin_iot_data.io_event
CREATE TABLE IF NOT EXISTS `io_event` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `datapacket_id` int(10) unsigned NOT NULL,
  `event_name` varchar(50) NOT NULL,
  `value` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `datapacket_id_io_event` (`datapacket_id`),
  CONSTRAINT `datapacket_id_io_event` FOREIGN KEY (`datapacket_id`) REFERENCES `datapacket` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- Dumping data for table caradmin_iot_data.io_event: ~0 rows (approximately)
/*!40000 ALTER TABLE `io_event` DISABLE KEYS */;
/*!40000 ALTER TABLE `io_event` ENABLE KEYS */;

-- Dumping structure for table caradmin_iot_data.producer
CREATE TABLE IF NOT EXISTS `producer` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `mail` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

-- Dumping data for table caradmin_iot_data.producer: ~2 rows (approximately)
/*!40000 ALTER TABLE `producer` DISABLE KEYS */;
REPLACE INTO `producer` (`id`, `name`, `mail`) VALUES
	(1, 'Teltonika', NULL),
	(2, 'CSS Electronics', 'contact@csselectronics.com');
/*!40000 ALTER TABLE `producer` ENABLE KEYS */;

-- Dumping structure for table caradmin_iot_data.raw_data
CREATE TABLE IF NOT EXISTS `raw_data` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `io_event_id` int(10) unsigned NOT NULL,
  `name` varchar(50) NOT NULL,
  `value` varchar(50) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `io_event_id_raw_data` (`io_event_id`),
  CONSTRAINT `io_event_id_raw_data` FOREIGN KEY (`io_event_id`) REFERENCES `io_event` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Dumping data for table caradmin_iot_data.raw_data: ~0 rows (approximately)
/*!40000 ALTER TABLE `raw_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `raw_data` ENABLE KEYS */;

-- Dumping structure for table caradmin_iot_data.vehicle
CREATE TABLE IF NOT EXISTS `vehicle` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `vehicle_type_id` int(10) unsigned NOT NULL,
  `model` varchar(50) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `vehicle_type_id_vehicle` (`vehicle_type_id`),
  CONSTRAINT `vehicle_type_id_vehicle` FOREIGN KEY (`vehicle_type_id`) REFERENCES `vehicle_type` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

-- Dumping data for table caradmin_iot_data.vehicle: ~4 rows (approximately)
/*!40000 ALTER TABLE `vehicle` DISABLE KEYS */;
REPLACE INTO `vehicle` (`id`, `vehicle_type_id`, `model`) VALUES
	(1, 2, 'Toyota Avensis (2009)'),
	(2, 1, 'Zetor (1978)'),
	(3, 3, 'Actros F'),
	(4, 1, 'John Deere 7R250');
/*!40000 ALTER TABLE `vehicle` ENABLE KEYS */;

-- Dumping structure for table caradmin_iot_data.vehicle_type
CREATE TABLE IF NOT EXISTS `vehicle_type` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;

-- Dumping data for table caradmin_iot_data.vehicle_type: ~3 rows (approximately)
/*!40000 ALTER TABLE `vehicle_type` DISABLE KEYS */;
REPLACE INTO `vehicle_type` (`id`, `name`) VALUES
	(1, 'traktor'),
	(2, 'personbil'),
	(3, 'lastebil');
/*!40000 ALTER TABLE `vehicle_type` ENABLE KEYS */;

/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IF(@OLD_FOREIGN_KEY_CHECKS IS NULL, 1, @OLD_FOREIGN_KEY_CHECKS) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
