package simulation;

/**
 * Generere CRC-kode
 */
public class Crc {
    /**
     * Generere CRC-kode
     *
     * @param data byte-array
     * @return crc koden
     */
    public static int crcChecker(byte[] data) {
        int len = data.length;
        int polynom = 0xA001;
        int crc = 0x000;

        for (int i = 8; i < (len - 4); i++) {
            int tmp = data[(i) % (len - 4)] & 0xFF;
            crc ^= tmp;
            for (int j = 0; j < 8; j++) {
                if ((crc & 0x0001) != 0) crc = (crc >> 1) ^ polynom;
                else crc = crc >> 1;
            }
        }
        return crc & 0xFFFF;
    }
}
