package simulation.avl;

public class AvlPackage {
    private long timestamp;
    private int priority;
    private Gps gps;
    private IoElements ioElements;

    public AvlPackage(long timestamp, int priority) {
        this.timestamp = timestamp;
        this.priority = priority;
        this.gps = new Gps(0, 0, 0, 0, 0, 0);
        this.ioElements = new IoElements();
    }

    String getTimestampHex() {
        return Avl.longToHex(this.timestamp, 8);
    }

    String getPriorityHex() {
        return Avl.intToHex(this.priority, 1);
    }

    int getSize() {
        return this.toString().length() / 2;
    }

    Gps getGps() {
        return this.gps;
    }

    public void setGps(Gps gps) {
        this.gps = gps;
    }

    IoElements getIoElements() {
        return this.ioElements;
    }

    public void setIoElements(IoElements io) {
        this.ioElements = io;
    }

    @Override
    public String toString() {
        return this.getTimestampHex() +
                this.getPriorityHex() +
                this.gps +
                this.ioElements;
    }
}
