package simulation.avl;

import java.util.ArrayList;

public class IoElements {
    private int eventId = 0;

    private IoArray io1byte;
    private IoArray io2byte;
    private IoArray io4byte;
    private IoArray io8byte;
    private IoArray ioxbyte;

    class IoArray {

        private ArrayList<Io> io;

        IoArray() {
            this.io = new ArrayList();
        }

        void add(Io io) {
            this.io.add(io);
        }

        int getCount() {
            return this.io.size();
        }

        @Override
        public String toString() {
            String out = Avl.intToHex(this.getCount(), 2);
            for (Io io : this.io) out += io;
            return out;
        }
    }

    public IoElements() {
        this.io1byte = new IoArray();
        this.io2byte = new IoArray();
        this.io4byte = new IoArray();
        this.io8byte = new IoArray();
        this.ioxbyte = new IoArray();
    }

    String getEventIdHex() {
        return Avl.intToHex(this.eventId, 2);
    }

    int getCount() {
        return this.io1byte.getCount() +
                this.io2byte.getCount() +
                this.io4byte.getCount() +
                this.io8byte.getCount() +
                this.ioxbyte.getCount();
    }

    String getCountHex() {
        return Avl.intToHex(this.getCount(), 2);
    }

    public void add(Io io) {
        switch (io.size) {
            case 1:
                this.io1byte.add(io);
                break;
            case 2:
                this.io2byte.add(io);
                break;
            case 4:
                this.io4byte.add(io);
                break;
            case 8:
                this.io8byte.add(io);
                break;
            default:
                this.ioxbyte.add(io);
        }
    }

    @Override
    public String toString() {
        return this.getEventIdHex() +
                this.getCountHex() +
                this.io1byte +
                this.io2byte +
                this.io4byte +
                this.io8byte +
                this.ioxbyte;
    }
}
