package dataprocessing.output;

/**
 * GPS-klasse som inneholder all GPS-data relatert til en datapakke.
 */
public class GpsElement {
    private double longitude;
    private double latitude;
    private short altitude;
    private short angle;
    private byte noOfSatellites;

    /**
     * Konstruktør for et GPS-Element
     *
     * @param longitude      Lengdegrad
     * @param latitude       Breddegrad
     * @param altitude       Høyde
     * @param angle          Vinkel
     * @param noOfSatellites Antall satellitter
     */
    public GpsElement(double longitude, double latitude, short altitude, short angle, byte noOfSatellites) {
        this.longitude = longitude;
        this.latitude = latitude;
        this.altitude = altitude;
        this.angle = angle;
        this.noOfSatellites = noOfSatellites;
    }

    public double getLongitude() {
        return longitude;
    }

    public double getLatitude() {
        return latitude;
    }

    public short getAltitude() {
        return altitude;
    }

    public short getAngle() {
        return angle;
    }

    public byte getNoOfSatellites() {
        return noOfSatellites;
    }

    /**
     * Returner tekst med klassen og dens data
     *
     * @return Tekst med klassen og dens data
     */
    @Override
    public String toString() {
        return "\n\t\tlongitude: " + longitude +
                "\t\tlatitude: " + latitude +
                "\n\t\taltitude: " + altitude +
                "\n\t\tangle: " + angle +
                "\n\t\tnoOfSatellites: " + noOfSatellites;
    }
}