package dataprocessing.output;

/**
 *  Klasse som inneholder utolket data fra enheten
 */
public class RawData {
    private final String name;
    private final String value;

    /**
     * Konstruktøren til rådata
     *
     * @param name navnet på kilden
     * @param value verdien
     */
    public RawData(String name, String value) {
        this.name = name;
        this.value = value;
    }

    /**
     * @return Navnet på opphavskilden
     */
    public String getName() {
        return name;
    }

    /**
     * @return leset verdien
     */
    public String getValue() {
        return value;
    }

    @Override
    public String toString() {
        return "RawData{" +
                "name='" + name + '\'' +
                ", value='" + value + '\'' +
                '}';
    }
}
