package dataprocessing.output.equipment;


import dataprocessing.output.RawData;

import java.util.ArrayList;
import java.util.List;

/**
 * Bunnstruktur for Equipment-objekter.
 * Blir lagret som IO-event i databasen
 */
public abstract class Equipment {
    private final ArrayList<RawData> rawData = new ArrayList<>();
    private final String name;


    protected Equipment(String name){
        this.name = name;
    }

    /**
     * @return Navnet til utstyret
     */
    public String getName(){
        return name;
    }

    /**
     * @return Statusen til utstyret
     */
    public abstract String getState();

    /**
     *  Legger til rå data som var grunnlaget til tolkningen
     *
     * @param name Navnet på parameteren
     * @param value Verdien til parameteren
     */
    public void addRawData(String name, String value) {
        rawData.add(new RawData(name, value));
    }

    /**
     * @return Liste med rå data
     */
    public List<RawData> getRawData() {
        return rawData;
    }
}
