package networking;

import tools.DeviceFamily;

/**
 * Abstarkt klasse som inneholder mottatt data fra enhet
 */
public abstract class Packet {
    private final Client client;
    private final DeviceFamily deviceFamily;

    /**
     *
     * @param client Klienten som mottokk dataen
     * @param deviceFamily enhetsfamilien til enheten
     */
    protected Packet(Client client, DeviceFamily deviceFamily) {
        this.client = client;
        this.deviceFamily = deviceFamily;
    }

    /**
     * @return klienten
     */
    public Client getClient() {
        return client;
    }

    /**
     * @return enhetsfamilien
     */
    public DeviceFamily getDeviceFamily() {
        return deviceFamily;
    }

    /**
     * Abstrakt funksjon som returnerer dataen
     *
     * @param <T> typen til dataen
     * @return dataen
     */
    public abstract <T> T getData();
}
