package networking.teltonikafmc;

import networking.Client;
import networking.Listener;
import networking.Server;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.net.Socket;

/**
 * Lytter til TeltonikaFMC enheter
 */
public class TeltonikaFmcListener extends Listener {

    /**
     * Initiere med port-nummer 8160
     */
    public TeltonikaFmcListener(Server handler) {
        super(handler, 8160);
    }


    /**
     * Lager en ny TeltonikaFMCKlient
     *
     * @param socket Socket-objekt
     * @param input  Input-Objekt
     * @param output Output-Objekt
     * @return TeltonikaFMCKlienten
     */
    @Override
    protected Client createClient(Socket socket, DataInputStream input, DataOutputStream output) {
        return new TeltonikaFmcClient(handler, socket, input, output);
    }
}
