package networking.teltonikafmc;

import tools.DeviceFamily;
import networking.Packet;

/**
 * Inneholder data mottatt fra TeltonikaFMC enheter
 */
public class TeltonikaFmcPacket extends Packet {
    private final byte[] data;

    /**
     *
     * @param client KLienten som sende dataen
     * @param data dataen som ble mottatt
     */
    public TeltonikaFmcPacket(TeltonikaFmcClient client, byte[] data) {
        super(client, DeviceFamily.TELTONIKA_FMC);
        this.data = data;
    }

    /**
     * @return Returnerer mottatt data i form av en byte-array
     */
    @Override
    public byte[] getData() {
        return data;
    }
}