package test;

import java.util.logging.Level;
import java.util.logging.Logger;

import org.junit.jupiter.api.Test;

import static tools.DataConverter.byteToInt16;
import static tools.DataConverter.byteToInt32;
import static tools.DataConverter.byteToInt64;
import static tools.DataConverter.byteToInt8;
import static org.junit.jupiter.api.Assertions.*;


public class DataConverterTest {

    Logger logger = Logger.getLogger(DataConverterTest.class.getName());

    byte[] bytes = new byte[] {0x00, 0x00, 0x01, 0x00, 0x01, 0x01, 0x01, 0x00, 0x01, 0x00};
    int offset = 2;


    @Test
    void testbyteToInt8(){
        logger.log(Level.INFO,"Test byteToInt8: ");
        assertEquals(1,byteToInt8(bytes,offset));
        assertNotEquals(6,byteToInt8(bytes,offset));
        logger.log(Level.INFO,"Test OK");
    }

    @Test
    void testbyteToInt16(){
        logger.log(Level.INFO,"Test byteToInt16: ");
        assertEquals(256,byteToInt16(bytes,offset));
        assertNotEquals(429,byteToInt16(bytes,offset));
        logger.log(Level.INFO,"Test OK");
    }


    @Test
    void testbyteToInt32(){
        logger.log(Level.INFO,"Test byteToInt32: ");
        assertEquals(16777473,byteToInt32(bytes,offset));
        assertNotEquals(1677473,byteToInt32(bytes,offset));
        logger.log(Level.INFO,"Test OK");
    }

    @Test
    void testbyteToInt64(){
        logger.log(Level.INFO,"Test byteToInt64: ");
        assertEquals(72058697861300480L,byteToInt64(bytes,offset));
        assertNotEquals(72058697861300481L,byteToInt64(bytes,offset));
        logger.log(Level.INFO,"Test OK");
    }
}
