package test;

import database.Database;
import database.ParsedDataSqlStatements;
import dataprocessing.output.PacketContainer;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import static org.junit.jupiter.api.Assertions.assertEquals;


public class DatabaseTest {
    PacketContainer packet;

    @BeforeEach
    void setup() {
        Database.getInstance().init("./res/db_credentials.properties");

        packet = new PacketContainer();
        packet.setDateAndTime(1);
        packet.setGpsElement(1L, 1L, (short) 1, (short) 1, (byte) 1);
    }

    @Test
    void TestDatapacket() {
        try {
            var c = Database.getInstance().getConnection();

            int id = ParsedDataSqlStatements.addDataPacket(c, packet, 1);
            PreparedStatement ps = c.prepareStatement("SELECT * FROM datapacket WHERE id=" + id);
            ResultSet result = ps.executeQuery();
            result.next();
            assertEquals(id, result.getInt(1));
            assertEquals(1, result.getInt(2));
            assertEquals(new Date(packet.getDateAndTime()).toString(), result.getDate(3).toString());
            ParsedDataSqlStatements.removeDataPacket(c, id);
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
    }
}
