package test;


import dataprocessing.teltonika.TeltonikaParameters;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

public class IoElementParametersTest {

    Logger logger = Logger.getLogger(IoElementParametersTest.class.getName());
    String e = (".root.csv");
    String s = ("./res/FMC130_parameters.csv");
    String t = ("./res/FMC130_parameters");
    TeltonikaParameters teltonikaParameters;


    @BeforeEach
    void setUp(){
        teltonikaParameters = new TeltonikaParameters(s);
    }

    @Test
    void testReadCsv(){
        logger.log(Level.INFO,"Test 1: Read Csv");
        assertTrue(teltonikaParameters.readCsv(s));
        logger.log(Level.INFO,"Test 2: Read Csv");
        assertFalse(teltonikaParameters.readCsv(e));
        logger.log(Level.INFO,"Test 3: Read Csv");
        assertFalse(teltonikaParameters.readCsv(t));
    }

    @Test
    void testIoParameters(){
        var io = this.teltonikaParameters.getElement(9);
        logger.log(Level.INFO,"Test 1: Id");
        assertEquals(9, io.getId());
        logger.log(Level.INFO,"Test 2: Name");
        assertEquals("Analog Input 1", io.getName());
        logger.log(Level.INFO,"Test 3: Size");
        assertEquals(2, io.getBytes());
        logger.log(Level.INFO,"Test 4: Type");
        assertEquals("Unsigned", io.getType());
        logger.log(Level.INFO,"Test 5: Min");
        assertEquals("0", io.getMin());
        logger.log(Level.INFO,"Test 6: Max");
        assertEquals("65535", io.getMax());
        logger.log(Level.INFO,"Test 7: Multiplier");
        assertEquals(0.001, io.getMultiplier());
        logger.log(Level.INFO,"Test 8: Limit");
        assertEquals(0, io.getLimit());
    }
}
